/* 
 * File:   main.cpp
 * Author: cteam045
 *
 * Created on October 22, 2016, 1:11 PM
 */

#include <cstdlib>
#include <vector>
#include <iostream>
using namespace std;


vector< vector< char> > data;


char up_symbol(char c){
    switch(c){
        case '<': return '^';
        case '>': return '^';
        case '^': return '^';
        case 'v': return '^';
        case 'o': return 'o';
        case 'x': return 'x';
        case '|': return '|';
        case '-': return '|';
        case '/': return '/';
        case '\\': return '\\';
        default: return c;
    }
}

char down_symbol(char c){
     switch(c){
        case '<': return 'v';
        case '>': return 'v';
        case '^': return 'v';
        case 'v': return 'v';
        case 'o': return 'o';
        case 'x': return 'x';
        case '|': return '|';
        case '-': return '|';
        case '/': return '/';
        case '\\': return '\\';
          default: return c;
        
    }
    
}

char left_symbol(char c){
    switch(c){
        case '<': return '>';
        case '>': return '>';
        case '^': return '>';
        case 'v': return '>';
        case 'o': return 'o';
        case 'x': return 'x';
        case '|': return '-';
        case '-': return '-';
        case '/': return '/';
        case '\\': return '/';
          default: return c;
        
    }
}

char right_symbol(char c){
    switch(c){
        case '<': return '<';
        case '>': return '<';
        case '^': return '<';
        case 'v': return '<';
        case 'o': return 'o';
        case 'x': return 'x';
        case '|': return '-';
        case '-': return '-';
        case '/': return '\\';
        case '\\': return '\\';
          default: return c;
        
    }
}

void flip_horizontal(){
     for(int i = 0; i < data.size()/2; i++){
        for(int j = 0; j < data[0].size(); j++){
            char tempChar =data[i][j] ;
            data[i][j] = up_symbol(data[ data.size()-i-1][j]);
            data[ data.size()-i-1][j] = down_symbol(tempChar);   
            
        }
    }

}

void flip_vertical(){
    for(int i = 0; i < data.size(); i++){
        for(int j = 0; j < data[0].size()/2; j++){
            char tempChar =data[i][j] ;
            data[i][j] = left_symbol(data[i][data[0].size() - j -1 ]);
            data[i][data[0].size() - j -1] = right_symbol(tempChar);           
        }
    }
}

void flip_main_diagonal(){
      for(int i = 0; i < data.size(); i++){
        for(int j = i; j < data[0].size(); j++){
            char tempChar =data[i][j] ;
            data[i][j] = up_symbol(data[j][i]);
            data[j][i] = down_symbol(tempChar);   
            
        }
    }
}

void flip_anti_diagonal(){
     for(int i = 0; i < data.size(); i++){
        for(int j = 0; j< i; j++){
            char tempChar =data[data.size() - i - 1][data.size() - j - 1] ;
            data[data.size() - i - 1][data.size() -j -1] = data[i][j];
            data[i][j] = tempChar;   
            
        }
    }
}

void rotate_left(){
   flip_vertical();
   flip_main_diagonal();
}

void rotate_right(){
    flip_horizontal();
    flip_main_diagonal();
}



void print(){
    for(int i =0; i < data.size(); i++){
        for(int j = 0; j < data[i].size(); j++){
            cout << data[i][j];
        }
        cout << endl;
    }
}

void read(){
    
    int num;
    cin >> num;
   // while(){
        for(int i = 0; i < num; i++){
            string row;
            cin >> row;
            vector<char> temp;
            for(auto & c : row){
                temp.push_back(c);
            }
            data.push_back(temp);
        }
   // }
    
    //now read commands
    string commands;
    cin >> commands;
    
    for(auto & c : commands){
        if(c == '<') rotate_left();
        if(c == '>') rotate_right();
        if(c == '-') flip_horizontal();
        if(c == '|') flip_vertical();
        if(c == '/') flip_anti_diagonal();
        if(c == '\\') flip_main_diagonal();
    }
}

/*
 * 
 */
int main(int argc, char** argv) {
    
    //vector<vector<char> > temp;
    read();
    print();
    return 0;
}

